## ros-foxy-robot-controllers 0.8.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(robot_controllers)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(orocos_kdl REQUIRED)
find_package(ament_cmake REQUIRED)
find_package(angles REQUIRED)
find_package(control_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(kdl_parser REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_action REQUIRED)
find_package(robot_controllers_interface REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(trajectory_msgs REQUIRED)
find_package(urdf REQUIRED)

include_directories(
  include
  SYSTEM ${orocos_kdl_INCLUDE_DIRS}
)

add_library(robot_controllers SHARED
  src/cartesian_pose.cpp
  src/cartesian_twist.cpp
  src/cartesian_wrench.cpp
  src/diff_drive_base.cpp
  src/follow_joint_trajectory.cpp
  src/gravity_compensation.cpp
  src/parallel_gripper.cpp
  src/pid.cpp
  src/point_head.cpp
  src/scaled_mimic.cpp
  src/mimic_joint_handle.cpp
)
target_link_libraries(robot_controllers
  ${orocos_kdl_LIBRARIES}
)
ament_target_dependencies(robot_controllers
  control_msgs
  geometry_msgs
  kdl_parser
  nav_msgs
  pluginlib
  rclcpp
  rclcpp_action
  robot_controllers_interface
  sensor_msgs
  tf2_geometry_msgs
  tf2_ros
  trajectory_msgs
  urdf
)
target_compile_definitions(robot_controllers PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")

if (BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  ament_add_gtest(${PROJECT_NAME}-trajectory-tests test/trajectory_tests.cpp)
  ament_target_dependencies(${PROJECT_NAME}-trajectory-tests
    angles
    rclcpp
    robot_controllers_interface
  )
  target_compile_definitions(${PROJECT_NAME}-trajectory-tests PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")

  find_package(ament_cmake_cpplint)
  ament_cpplint(FILTERS "-whitespace/braces" "-whitespace/newline")
endif()

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS robot_controllers
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/robot_controllers
)

pluginlib_export_plugin_description_file(robot_controllers_interface robot_controllers.xml)

ament_export_include_directories(include)
ament_export_libraries(robot_controllers)
ament_export_dependencies(
  control_msgs
  geometry_msgs
  kdl_parser
  nav_msgs
  pluginlib
  rclcpp
  rclcpp_action
  robot_controllers_interface
  sensor_msgs
  tf2_geometry_msgs
  tf2_ros
  trajectory_msgs
  urdf
)
ament_package()

=== debian/changelog ===
ros-foxy-robot-controllers (0.8.1-1focal) focal; urgency=high

  * add Fergs as maintainer (#65 <https://github.com/fetchrobotics/robot_controllers/issues/65>)
  * additional boost disabling (#64 <https://github.com/fetchrobotics/robot_controllers/issues/64>)
  * disable boost components of pluginlib (#63 <https://github.com/fetchrobotics/robot_controllers/issues/63>)
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Wed, 02 Dec 2020 05:00:00 -0000

ros-foxy-robot-controllers (0.8.0-1focal) focal; urgency=high

  * Add initial support for ROS2
  * fix threading bug in point head controller (#62 <https://github.com/fetchrobotics/robot_controllers/issues/62>)
  * get latest transform (#60 <https://github.com/fetchrobotics/robot_controllers/issues/60>)
  * add linter, fix errors (#48 <https://github.com/fetchrobotics/robot_controllers/issues/48>)
  * parallel gripper tested (#56 <https://github.com/fetchrobotics/robot_controllers/issues/56>)
  * remove hard coded frame in point_head (#55 <https://github.com/fetchrobotics/robot_controllers/issues/55>)
  * build fixes on eloquent (#54 <https://github.com/fetchrobotics/robot_controllers/issues/54>)
  * add support for 4wd bases (#53 <https://github.com/fetchrobotics/robot_controllers/issues/53>)
  * test, fix and improve scaled_mimic (#52 <https://github.com/fetchrobotics/robot_controllers/issues/52>)
  * fix bug in laser checking: robot would always go slow if laser safety was on.
  * Uses C++14
  * make preemption work
  * fix uninitialized time that would occasionally cause std::runtime_error* improve logging
  * switch to service interface
  * port all controllers and tested
  * add util/declare_parameter_once
  * Add time_from_start information to feedback topic (#38 <https://github.com/fetchrobotics/robot_controllers/issues/38>)
  * [GCC][Warnings] SYSTEM includes and catch ref (#36 <https://github.com/fetchrobotics/robot_controllers/issues/36>)
    This is an attempt to fix (silence) the buildbot failures from -Werror
  * Updates maintainers
  * Add init trajectory for future start time (#40 <https://github.com/fetchrobotics/robot_controllers/issues/40>)
  * Contributors: Alex Moriarty, Michael Ferguson, Naoya Yamaguchi, Russell Toris, Shingo Kitagawa

 -- Russell Toris <rtoris@fetchrobotics.com>  Wed, 25 Nov 2020 05:00:00 -0000

ros-foxy-robot-controllers (0.6.0-1focal) focal; urgency=high

  * updates ownership
  * Contributors: Russell Toris

 -- Russell Toris <rtoris@fetchrobotics.com>  Wed, 11 Jul 2018 04:00:00 -0000

ros-foxy-robot-controllers (0.5.3-1focal) focal; urgency=high

  * remove limiter
  * Improve cartesian twist controller (#26 <https://github.com/fetchrobotics/robot_controllers/issues/26>)
  * Contributors: Hanjun Song, Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Sun, 11 Jun 2017 04:00:00 -0000

ros-foxy-robot-controllers (0.5.2-1focal) focal; urgency=high

  * do not export python library for linking
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Mon, 18 Jul 2016 04:00:00 -0000

ros-foxy-robot-controllers (0.5.1-1focal) focal; urgency=high

  * base_controller: only update odometry if inputs are finite (prevents NANs to TF)
  * base_controller: add velocity limiting
  * pid: fix error in derivative error calculation
  * allow velocity limiting code be reused for forward simulation #18 <https://github.com/fetchrobotics/robot_controllers/issues/18>
  * Contributors: Cappy Pitts, Derek King, Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Mon, 18 Jul 2016 04:00:00 -0000

ros-foxy-robot-controllers (0.5.0-1focal) focal; urgency=high

  * require finite commands to base controller
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Sun, 21 Feb 2016 05:00:00 -0000

ros-foxy-robot-controllers (0.4.3-1focal) focal; urgency=high

  * fix path/goal tolerance preparation
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Sat, 05 Dec 2015 05:00:00 -0000

ros-foxy-robot-controllers (0.4.2-1focal) focal; urgency=high

  * fixed segmentation faults due to misconfiguration
  * Contributors: Arvin Asokan

 -- Russell Toris <rtoris@fetchrobotics.com>  Thu, 22 Oct 2015 04:00:00 -0000

ros-foxy-robot-controllers (0.4.1-1focal) focal; urgency=high

  * add centering pid to gripper controller
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Fri, 12 Jun 2015 04:00:00 -0000

ros-foxy-robot-controllers (0.4.0-1focal) focal; urgency=high



 -- Russell Toris <rtoris@fetchrobotics.com>  Sat, 23 May 2015 04:00:00 -0000

ros-foxy-robot-controllers (0.3.4-1focal) focal; urgency=high

  * add ability to reset controllers
  * add timeout to laser speed scaling
  * maintain constant curvature when scaling base velocity
  * remove DiffDriveBaseController::publish()
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Fri, 22 May 2015 04:00:00 -0000

ros-foxy-robot-controllers (0.3.3-1focal) focal; urgency=high

  * use laser to slow base when obstacles are near
  * add mutexes around command/odometry. publish odom in timer
  * add -Wall to compile flags, fix compile warnings
  * Contributors: Derek King, Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Sun, 03 May 2015 04:00:00 -0000

ros-foxy-robot-controllers (0.3.2-1focal) focal; urgency=high



 -- Russell Toris <rtoris@fetchrobotics.com>  Thu, 09 Apr 2015 04:00:00 -0000

ros-foxy-robot-controllers (0.3.1-1focal) focal; urgency=high

  * use shortest_angular_distance for diff drive dx calculations
  * Contributors: Michael Ferguson

 -- Russell Toris <rtoris@fetchrobotics.com>  Sat, 28 Mar 2015 04:00:00 -0000

ros-foxy-robot-controllers (0.3.0-1focal) focal; urgency=high

  * improve windup support
  * make spliced trajectory consistent in qd/qdd size
  * Contributors: Michael Ferguson



=== debian/control ===
Source: ros-foxy-robot-controllers
Section: misc
Priority: optional
Maintainer: Russell Toris <rtoris@fetchrobotics.com>
Build-Depends: debhelper (>= 9.0.0), liborocos-kdl-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-cpplint, ros-foxy-ament-cmake-gtest, ros-foxy-angles, ros-foxy-control-msgs, ros-foxy-geometry-msgs, ros-foxy-kdl-parser, ros-foxy-nav-msgs, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-rclcpp-action, ros-foxy-robot-controllers-interface, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-tf2-geometry-msgs, ros-foxy-tf2-ros, ros-foxy-trajectory-msgs, ros-foxy-urdf, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-robot-controllers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, liborocos-kdl-dev, ros-foxy-angles, ros-foxy-control-msgs, ros-foxy-geometry-msgs, ros-foxy-kdl-parser, ros-foxy-nav-msgs, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-rclcpp-action, ros-foxy-robot-controllers-interface, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-tf2-geometry-msgs, ros-foxy-tf2-ros, ros-foxy-trajectory-msgs, ros-foxy-urdf, ros-foxy-ros-workspace
Description: Some basic robot controllers for use with robot_controllers_interface.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-robot-controllers//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
